/*********Smart car tracking function*******/
//Define tracking module interface
 #define LT_R digitalRead(10)
 #define LT_M digitalRead(4)
 #define LT_L digitalRead(2)
//Defining the motor interface
#define ENA 5
#define ENB 6
#define IN1 7
#define IN2 8
#define IN3 9
#define IN4 11
//电机PWM调速
#define carSpeed 200
int left_LED = 16;
int Right_LED = 17;

/***小车前进****/
void forward_run()
{
   analogWrite(ENA,carSpeed);
   analogWrite(ENB,carSpeed);
   digitalWrite(IN1,LOW);
   digitalWrite(IN2,HIGH);
   digitalWrite(IN3,HIGH);
   digitalWrite(IN4,LOW);
   digitalWrite(left_LED,LOW);
   digitalWrite(Right_LED,LOW);
   Serial.println("go forward!");
 }

 /****小车后退****/
void back_run()
{
   analogWrite(ENA,carSpeed);
   analogWrite(ENA,carSpeed);
   digitalWrite(IN1,HIGH);
   digitalWrite(IN2,LOW);
   digitalWrite(IN3,LOW);
   digitalWrite(IN4,HIGH);
   Serial.println("go back!"); 
  
 }

 /*****小车左转*****/
 void left_run()
 {
   analogWrite(ENA,carSpeed);
    analogWrite(ENB,carSpeed);
    digitalWrite(IN1,HIGH);
    digitalWrite(IN2,LOW);
    digitalWrite(IN3,HIGH);
    digitalWrite(IN4,LOW);
    digitalWrite(left_LED,LOW);
    digitalWrite(Right_LED,HIGH);
    Serial.println("go left!");
  }
 /*******小车右转*******/
 void right_run()
 {
   analogWrite(ENA,carSpeed);
   analogWrite(ENB,carSpeed);
   digitalWrite(IN1,LOW);
   digitalWrite(IN2,HIGH);
   digitalWrite(IN3,LOW);
   digitalWrite(IN4,HIGH);
   digitalWrite(left_LED,HIGH);
   digitalWrite(Right_LED,LOW);
   Serial.println("go right!");
  }
/******小车停止*******/
void stop()
{
  digitalWrite(ENA,LOW);
  digitalWrite(ENB,LOW);
  Serial.println("Stop!");
 }
/**********声明函数*************/
void setup()
{
  Serial.begin(9600);
  pinMode(LT_R,INPUT);
  pinMode(LT_M,INPUT);
  pinMode(LT_L,INPUT);
  pinMode(left_LED,OUTPUT);
  pinMode(Right_LED,OUTPUT);
}

void loop()  
{
   if(LT_M)  //如果目前检测到中间有黑线
   { 
      forward_run();//前进  
    
    }
   else if(LT_R)//如果目前检测到右边有黑线
   {
      right_run();//右转
      while(LT_R);//向右转
     
        }
    else if(LT_R&&LT_L==1)//如果检测到左右两边都有黑线
    {
        forward_run();//前进
      }
   else if(LT_L)//如果目前为检测到左边有黑线
   {
      left_run();//左转
      while(LT_L);//向左转
    }
    else if(LT_L&&LT_M==1)//如果检测到左边和中间都有黑线
    {
         left_run();//向左
          delay(2); 
      }
    else if(LT_R&&LT_M==1)//如果检测到右边和中间都有黑线
    {
          right_run();//向右
          delay(2);
      }
           
     else if (LT_L&&LT_M&&LT_R==1 )//如果检测到左中右都黑线右就执行
      {
          left_run();//向前
        }        
}
